--[[
	ExtremaRatioAssistant: gestisci gli inviti ai raid per gli Extrema Ratio
	anche noto come FIGOLAS
	
	Fantastico
	Invitatore di
	Gildani
	Ottimizzato per
	L'
	Autoinvito
	Sicuro
	
	by Stormbeard - Pozzo Dell'Eternità, gilda Extrema Ratio
]]---
local addonName, vars = ...
local L = vars.L --- localizzazione
local ERA = LibStub("AceAddon-3.0"):NewAddon(addonName, "AceTimer-3.0","AceEvent-3.0")
_G[addonName] = ERA
local ACEGUI

--***************************************
--<UPVALUE>
local pairs = pairs
local ipairs = ipairs
local print = print
local unpack = unpack
local type = type
local next = next
local tinsert = table.insert
local tsort = table.sort
local wipe = wipe
local format = string.format
local match = string.match
local find = string.find
local lower = string.lower
local upper = string.upper
local gsub = gsub
local gmatch = string.gmatch
local setmetatable = setmetatable
local IsInRaid = IsInRaid
local IsInGroup = IsInGroup
local UnitIsGroupLeader = UnitIsGroupLeader
local UnitInParty = UnitInParty
local UnitInRaid = UnitInRaid
local InviteUnit = InviteUnit
local UnitPlayerOrPetInRaid = UnitPlayerOrPetInRaid
local SetLootMethod = SetLootMethod
local PromoteToAssistant = PromoteToAssistant
local DemoteAssistant = DemoteAssistant
local UnitGUID = UnitGUID
local GetNumGroupMembers = GetNumGroupMembers
local UnitIsRaidOfficer = UnitIsRaidOfficer
local UnitIsUnit = UnitIsUnit
local GetUnitName = GetUnitName
local UnitName = UnitName
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local GetPartyAssignment = GetPartyAssignment
local CreateFrame = CreateFrame
local ConvertToRaid = ConvertToRaid
local SendChatMessage = SendChatMessage
local GetNumGuildMembers = GetNumGuildMembers
local GetGuildRosterInfo = GetGuildRosterInfo
local GuildRoster = GuildRoster
local CanGuildPromote = CanGuildPromote
local CanGuildDemote = CanGuildDemote
local SetGuildMemberRank = SetGuildMemberRank
local UninviteUnit = UninviteUnit
local GameTooltip = GameTooltip
local UnitAffectingCombat = UnitAffectingCombat

local _


--</UPVALUE>

--***************************************

--<VARIABILI>
local db = {}
local delay = 0.5 --ritardo con cui si eseguono i comandi, per evitare lockout
local on = L["Autoinvito \|cFF00FF00ON\|r"]
local off =  L["Autoinvito \|cFFFF0000OFF\|r"]
local ON = L["\|cFF00FF00ON\|r"]
local OFF = L["\|cFFFF0000OFF\|r"]
local status = { --una maniera contorta per usare una stringa...
	--"accettati","pendenti","potenziali",
	["accettato"]="accettato",
	["invitato"]="invitato",
	["potenziale"]="potenziale",
	["imbucato"] = "imbucato"
}
local aspetto= {
	--pendenti = [[|TInterface\RaidFrame\ReadyCheck-Waiting|t|cFFFFFF00%s|r]],--gialli con ? 
	--potenziali = [[|TInterface\RaidFrame\ReadyCheck-Waiting|t%s]],--bianchi con ? davanti
	--accettati = [[|TInterface\RaidFrame\ReadyCheck-Ready|t|cFF00FF00%s|r]],---verdi con baffo davanti
	--imbucati = [[|cFF0000FF%s|r]],--? blu
	--rifiutati = [[|TInterface\RaidFrame\ReadyCheck-NotReady|t|cFFFF0000%s|r]],--rossi con x davanti
	invitato = {--bianco
		r = 1,
		g = 1,
		b = 1,
		icona = [[Interface\RaidFrame\ReadyCheck-Waiting]],
		txt = "%s",
		tooltip = L["Invitato"],
		action = "",
		
	},	
	--potenziale = è il default, si fa riferimento a __index sotto
	accettato = {--verde
		r = 0,
		g = 1,
		b = 0,
		icona = [[Interface\RaidFrame\ReadyCheck-Ready]],
		txt = [[|cFF00FF00%s|r]],---verdi con baffo davanti
		tooltip = L["In gruppo"],
		action = "",
	},
	imbucato = {
		r = 0.41,
		g = 0.80,
		b = 0.94,
		icona = [[Interface\RaidFrame\ReadyCheck-Ready]],
		txt = [[|cFF69CCF0%s|r]],
		tooltip =L["In gruppo, non confermato"],
		action = L["Clicca per rimuovere dal gruppo"],
	},--? azzurro
	
	--rifiutati = [[|TInterface\RaidFrame\ReadyCheck-NotReady|t|cFFFF0000%s|r]],--rossi con x davanti
}
setmetatable(aspetto, {__index = function(t,k) 
         t[k] = {--rosso potenziale
            r = 1,--255,
            g = 0,--0,
            b = 0,--0,
            icona = [[Interface\RaidFrame\ReadyCheck-Waiting]],
            txt = [[|cFFFF0000%s|r]],
			tooltip = L["confermato"],
			action = L["Clicca per invitare"],
         }
         return t[k]
      end,
})
	
local DEFAULTDB = {
	profile={
		opzioni = {
			--monitor = nil,
			SetMT = true,
			EPGP = true,
			
			EPGPUICfg = {
				['**'] = {
					["txt"] = L["Pulsante"],
					--["recurring"] = "no",
					["awardAmount"] = 0,
					["recurringAmount"] = 0,
					["reason"] = "raid",
					--["decay"] = false,
					--["award"] = false,
					["recurringTime"] = 5,
				},--default for every keys			
			},
		},				
		raid = {
			roster = {
			},
			drafted = {
			},
			list = "",
		},
		whisper = {
		   kwordList = "raid",--le parole da usare per autoinvitarsi
		   --casesensitive -- 
		   safe = true, --blocca gli inviti durante i boss
		   startMsg = L["Autoinvitatevi scrivendomi raid."],--messaggio che appare quando si preme whisper
		   blacklist = {},--lista di persone non gradite
		   --minrankname = nil, --non inizializzato
		   guildOnly = true,
		   annuncia = true,
		   --on = nil, 
			--alwaysOn = nil,
			--maxLvlOnly = true,
			--minRank = nil,
			--minRankLvl = nil,
		},
		promozione = {
			--attiva = nil per sapere se la promozione e' attiva, non lo inizializzo
			--["up"] = 5,--grado per la promozione		
			--["upName"] = "Progress", --nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
			--["downName"] = "Legionario",--nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
			--["down"] = 6,--grado per la retrocessione
			MLooters = "",--list ML			
			--assist="Stormbeard, Niikko", --lista assist
			forzaLM = true, --forza l'uso del ML
			lootMethod="master",
			tankAssist = true,
			ultraPromossi = {}, --lista di quelli promossi che in origine avevano un grado inferiore a quello del grado di retrocessione
		},	
	},
}
--</VARIABILI>
--<UTILITY>
--works as pair but sorting keys

local function pairsByKeys (t, criterio)
      local sorted = {}
      for n in pairs(t) do tinsert(sorted, n) end
      tsort(sorted, criterio)
      local i = 0      -- iterator variable
      local iter = function ()   -- iterator function
        i = i + 1
        if sorted[i] == nil then return nil
        else return sorted[i], t[sorted[i]]
        end
      end
      return iter
    end

function copytable(obj, seen)
  if type(obj) ~= 'table' then return obj end
  if seen and seen[obj] then return seen[obj] end
  local s = seen or {}
  local res = setmetatable({}, getmetatable(obj))
  s[obj] = res
  for k, v in pairs(obj) do res[copytable(k, s)] = copytable(v, s) end
  return res
end

function ERA:InRaid(unit)
	return UnitPlayerOrPetInRaid(unit) and find(UnitGUID(unit) or "", "Player")
end

--i maledetti nomi dei pg servono a volte con server a volte senza
function ERA:GetName(name,returnserver)
	local n = name
	if not returnserver then
		n = match(n, "([^-]+)") --senza il server
	else
		local s
		n, s = match(n, "([^-]+)-*([^-]*)")
		s = s =="" and self.PGRealm or s		
		n = format("%s-%s",n,s)
		n = gsub(n,"%s","")
	end	
	 return n or ""
end
--wrapper per GetGuildRosterInfo che riporta valori da 0 (guildmaster) a x mentre ogni altra funzione di gilda si usano valori da 1 a x -_-
function ERA:GetGuildRosterInfo(i)
	local fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation = GetGuildRosterInfo(i)
	rankIndex = rankIndex and rankIndex+1 or nil
	return fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation
end

--**************************
--<GET/SET Generici>
--get/set a seconda di #info (il nodo nell'interfaccia delle opzioni)
local GET = {
	[1] = function(info) return db[info[#info]]end,
	[2] = function(info) return db[info[#info-1]][info[#info]]end,
	[3] = function(info) return db[info[#info-2]][info[#info-1]][info[#info]]end,
	[4] = function(info) return db[info[#info-3]][info[#info-2]][info[#info-1]][info[#info]]end,
	[5] = function(info) return db[info[#info-4]][info[#info-3]][info[#info-2]][info[#info-1]][info[#info]]end,
}

local SET = {
	[1] = function(info, val) db[info[#info]] = val end,
	[2] = function(info, val) db[info[#info-1]][info[#info]] = val end,
	[3] = function(info, val) db[info[#info-2]][info[#info-1]][info[#info]] = val end,
	[4] = function(info, val) db[info[#info-3]][info[#info-2]][info[#info-1]][info[#info]] = val end,
	[5] = function(info, val) db[info[#info-4]][info[#info-3]][info[#info-2]][info[#info-1]][info[#info]] = val end,
}
--GENERAL GET
function ERA:DBGet(info)
	return GET[#info](info)
end

--GENERAL SET
function ERA:DBSet(info, val)
	SET[#info](info, val)
end
--************************--
--funzioncina per creare un po' di spazio nelle opzioni
local function space(order, size)
	return {
		order = order,
		type = "description",
		name = "",
		width = size or "full",
	}
end

--ordina la lista dei pulsanti nelle opzioni
function ERA:SortView(tab)
	if not next(tab) then return end
	local i = 1
	for name in pairsByKeys(tab) do	
		tab[name].order = i
		i = i+1
	end
end

--rimuove il singolo dai draft (applicato al pulsante)
function ERA:RemoveFromDrafted(info)
	db.raid.drafted[info[#info]]=nil
	ERA.drafted[info[#info]] = nil
	ERA.totaldraft = ERA.totaldraft - 1
	ERA:SortView(ERA.drafted)
	ERA:AggiornaMonitor()
end

--aggiunge ai draft
function ERA:AddToDrafted(n)	
	db.raid.drafted[n] = n
	ERA.drafted[n] = setmetatable({},{ __index = {
		order = 10,
		type = "execute",		
		func = "RemoveFromDrafted",
		desc = L["Click per rimuoverlo dai confermati"],
		}})
	ERA.drafted[n].name = n
	ERA.totaldraft = ERA.totaldraft + 1
	ERA:AggiornaMonitor()
end

--aggiunge ai draft o rimuove dal roster a seconda dello stato della checkbox nelle opzioni.
function ERA:ManageMembers(info)
	if self.ar then
		db.raid.roster[info[#info]]=nil
		ERA.roster[info[#info]] = nil
		ERA:SortView(ERA.roster)
	else
		ERA:AddToDrafted(info[#info])	
		ERA:SortView(ERA.drafted)		
	end
end

--aggiunge il nome al roster. non che il roster si usi molto.
function ERA:AddToRoster(info, val)
	if not val then return end	
	val = gsub(val, "^%l", upper)
	db.raid.roster[val] = val
	ERA.roster[val] = setmetatable ({},{__index = {
		order = 10,
		type = "execute",		
		func = "ManageMembers",
		desc = function()
			local d = self.ar and L["rimuoverlo dai membri"] or L["aggiungerlo ai confermati"]
			return (L["Click per "]..d)
		end,
	}})
	ERA.roster[val].name = val,
	ERA:SortView(ERA.roster)
end

--toglie dalla blacklist(per ignorare gli autoinviti di alcuni)
function ERA:RemoveFromBlacklist(info)
	db.whisper.blacklist[info[#info]]=nil
	ERA.blacklist[info[#info]] = nil
	ERA:SortView(ERA.blacklist)
end
--aggiunge dalla blacklist(per ignorare gli autoinviti di alcuni)
function ERA:AddToBlacklist(info, val)
	if not val then return end	
	val = gsub(val, "^%l", upper)
	db.whisper.blacklist[val] = val
	ERA.blacklist[val] = setmetatable({}, {__index = {
		order = 10,
		type = "execute",		
		func = "RemoveFromBlacklist",
		desc = L["Click per rimuoverlo dalla blacklist."],
	}})
	ERA.blacklist[val].name = val
	ERA:SortView(ERA.blacklist)
end
--elimina tutti i confermati in un colpo solo
function ERA:WipeDrafted()
	for name in pairs(db.raid.drafted) do
		ERA.drafted[name]=nil
	end
	db.raid.drafted = {}
	ERA.totaldraft = 0
	ERA:AggiornaMonitor()
end
--evita che i nomi abbiano caratteri non ammessi
function ERA:Validate(info, name)
	if #name < 3 then return L["Nome troppo corto"] end
local forbidden = "([%d:()[%]{}+_=\\|`~,.<>/?!@#$%%^&*])"
	local bad = match(name, forbidden)
	return bad and format(L["Carattere non permesso: %s"], bad) or true
end
--converte la lista manuale nei confermati. Utile per importare la gente dal planner
function ERA:ListToDrafted(info, txt)	
	if not txt then return end
	local wlist = {}
	db.raid.list = txt
	for name in gmatch(txt, "([^%s,]+)") do
		if ERA:Validate(nil,name) == true then 
			name = gsub(name, "^%l", upper)
			wlist[name] = name
		end
	end
	ERA:WipeDrafted()
	for name in pairs(wlist) do	
		ERA:AddToDrafted(name)
	end
	ERA:SortView(ERA.drafted)	
	ERA:AggiornaMonitor()
end
--confermati in formato testuale: per editare la lista nell'editbox del monitor
function ERA:DraftedToList()
	local list = ""
		for name in pairsByKeys(db.raid.drafted) do
			list = format("%s%s, ",list,name)
		end
	return list
end

--esegue una funzione, i vararg sono devono essere già passati come tabella
function ERA:Run(func, args)
	func = type(func) == "function" and func or function()end
	args = args or {}
	args = type(args) ~= "table" and {args} or args
	func(unpack(args))
end
--funzione con un ritardo rispetto all'ultima programmata. per evitare di ammucchiare tanti ordini in pochi millisecondi
function ERA:Timed(func, ...)
	local args = {...}
	self.last = self:ScheduleTimer("Run",self:TimeLeft(self.last)+delay,func,args)
			
end
--promuove ad assistente.
function ERA:Promuovi()
	if IsInRaid() and UnitIsGroupLeader("player") then 		
		for name in gmatch(db.promozione.assist, "([^%s,]+)") do			
			if ERA:InRaid(name) and not UnitIsRaidOfficer(name) and not UnitIsUnit(UnitName(name), "player") then 				
			self:Timed(PromoteToAssistant, name)			
				--PromoteToAssistant(name)
			end			
		end
	end
end
--setta il LootMethod e assegna il  Master Looter in base alla lista nelle opzioni. 
function ERA:LootMethod()
	if IsInRaid() and UnitIsGroupLeader("player") then 	
		if not db.promozione.forzaLM then return end
		local method, _, master = GetLootMethod()	
		if method ~= db.promozione.lootMethod then			
				SetLootMethod(db.promozione.lootMethod,UnitName("player"))		
		end
		--regole per impostare il ML secondo la lista 
		if db.promozione.lootMethod =="master" then
			_, _, master = GetLootMethod()
			for name in gmatch(db.promozione.MLooters, "([^%s,]+)") do		
				if not master or UnitIsUnit("raid"..master, ERA:GetName(name)) then return end			
				if ERA:InRaid(name) and (not ERA.EPGP or not ERA.EPGP:RunningRecurringEP()) then		
					SetLootMethod("master",name)				
					return
				end
			end		
			--se il RL da i punti allora deve essere sempre il ML
			if (ERA.EPGP and ERA.EPGP:RunningRecurringEP() and not UnitIsUnit("raid"..master, "player")) then 
				SetLootMethod("master",UnitName("player"))		
			end
		end
	end
end

--tiene aggiornato il raid ed i ruoli
function ERA:GROUP_ROSTER_UPDATE()
	if IsInRaid() then
		self.isInRaid = true
		if UnitIsGroupLeader("player") then									
			self:LootMethod()
			self:Promuovi()
		end
	else
		if not UnitExists("party1") and self.isInRaid then --lascia il raid
			--inserire qui attività da fare quando il raid si disbanda	
			self:RegisterEvent("CHAT_MSG_SYSTEM") 
			ERA:PromozioneCheck()		
			self.isInRaid = nil
			self.startedInviting = nil
			if not db.whisper.alwaysOn and db.whisper.on then
				ERA:SwitchWhisper()
			end
		end
	end
	self:AggiornaMonitor()	
end

--leva/assegna gli assist ai tank che cambiano ruolo
function ERA:ROLE_CHANGED_INFORM(event, cPG, cBy, oldR, newR)
	if not db.promozione.tankAssist then return end
	if IsInRaid() and UnitIsGroupLeader("player") and not(UnitIsUnit(cPG, "player")) and (oldR == "TANK" or newR == "TANK") then
		if newR == "TANK" and not UnitIsRaidOfficer(cPG) then		
			PromoteToAssistant(cPG)				
		elseif oldR == "TANK" and UnitIsRaidOfficer(cPG) then		
			DemoteAssistant(cPG)		
		end	
	end
end

--*************FUNZIONI PER SETTARE I MAIN TANK****************
--le lascio in forma di funzione local per non incasinarmi nelle chiamate
local MTtxt = L["\|cFFFFFF00Assegna i Main Tank\|r"]
local function MTMacro(who, macro)
	if UnitGroupRolesAssigned(who) == "TANK" and not GetPartyAssignment("MAINTANK",who) then
macro = string.format([[%s%s%s
]],macro, "/mt ",who)
	end		
	if UnitGroupRolesAssigned(who) ~= "TANK" and GetPartyAssignment("MAINTANK",who) then
macro = string.format([[%s%s%s
]],macro, "/mtoff ",who)
	end
	return macro
end

--le lascio in forma di funzione local per non incasinarmi nelle chiamate
local function TankAssist(who)
	if UnitGroupRolesAssigned(who) == "TANK" and not UnitIsRaidOfficer(who) and not UnitIsUnit(who, "player") then		
		PromoteToAssistant(who)
	end	
end

function ERA:TankCheck()
	if IsInRaid() and UnitIsGroupLeader("player") then
		local MTMacro, TAss = MTMacro, TankAssist
		--funzione per settare la macro dei MT
		if  not db.opzioni.SetMT then			
			MTMacro = function()end
		end
		--funzione per settare la promozione dei tank
		if not db.promozione.tankAssist then
			TAss = function()end
		end
		--adesso facciamo un ciclo comune
		local macro = ""    
		local who
		for i = 1, GetNumGroupMembers() do
			who = "raid"..i
			macro = MTMacro(who,macro)
			TAss(who)
		end
		if macro ~="" then 
		ERA:AddAlert(MTtxt,"macro",macro)
		--ERA:DialogBox()		
		end
	end
end
--**************FINE MT*************
--setta i main tank
function ERA:READY_CHECK()
	self:TankCheck()
end

--l'unica maniera certa per sapere quando qualcuno si unisce al gruppo.
function ERA:CHAT_MSG_SYSTEM(event,txt,...)	 
	if IsInRaid() then 	return end --questo perche' lo usiamo solo per gruppare al momento.
	local name,what = match(txt,"(%S+)(.+)")	
	if ERA[what] then ERA[what](this,name) end
end

--indichiamo che siamo durante un incontro, bloccando gli inviti automatici
function ERA:ENCOUNTER_START()
    self.whisperBlock = true	
	ERA:RegisterEvent("PLAYER_REGEN_ENABLED")
end
--riprendiamo gli inviti automtici
function ERA:ENCOUNTER_END()	
	self.whisperBlock = nil
	ERA:UnregisterEvent("PLAYER_REGEN_ENABLED")	
	self:UpdateGuildRoster()
	--contatta chi voleva essere invitato e digli che può invitarsi, ma solo se i whisper sono attivi
	self:EvadiWhisper()
end

--controllo che l'incontro effettivamente finisca. piano B. ogni tanto encounter_end non viene intercettato.
function ERA:PLAYER_REGEN_ENABLED()
	if not self.whisperBlock then return end
	for i = 1, GetNumGroupMembers() do
		if UnitAffectingCombat("raid"..i) then
			--se ancora qualcuno si mena controlliamo tra un po'
			ERA:ScheduleTimer("PLAYER_REGEN_ENABLED", 5)
			return
		end
	end				
	--se siamo qui nessuno combatte più
	ERA:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self.whisperBlock = nil
	self:UpdateGuildRoster()
	--contatta chi voleva essere invitato e digli che può invitarsi, ma solo se i whisper sono attivi
	self:EvadiWhisper()				
end


function ERA:Invita(name)
	if not UnitIsUnit(ERA:GetName(name), "player") then 						
		--se non sono gia' nel party
		if not UnitPlayerOrPetInRaid(name) and not UnitPlayerOrPetInParty(name) and not UnitPlayerOrPetInRaid(ERA:GetName(name)) and not UnitPlayerOrPetInParty(ERA:GetName(name))then		
			self.startedInviting = true
			self:Timed(InviteUnit, name)			
		end
	end
end

--una coda di inviti. attualmente usata solo se qualcuno cerca di autoinvitarsi durante un incontro.
function ERA:EvadiWhisper()
	local who,i
	while #self.invitiRichiesti > 0 do 
		who = self.invitiRichiesti[#self.invitiRichiesti]
		if not ERA:InRaid(who) then
			self:WhisperInvita(who)
		end			
		table.remove(self.invitiRichiesti)		
	end
end

function ERA:ScheduleEvadiWisper()
	if not self.scheduled then
		self.scheduled = self:ScheduleTimer("EvadiWhisper",10)
	end
end
--gestisce l'autoinvito con le sua varie varianti
function ERA:WhisperInvita(name)--name deve essere nella forma nome-server

	if ERA:InRaid(name) then return end
	-- persone non nella blacklist
	if next(db.whisper.blacklist) and (db.whisper.blacklist[name] or db.whisper.blacklist[ERA:GetName(name)]) then
	   SendChatMessage(L["TU.. NON PUOI.. RAIDARE!"],"WHISPER", nil, name)
	   return
	end
	
	--se è sicuro e siamo nel self:whisperBlock non invitiamo
	if db.whisper.safe and self.whisperBlock then
		SendChatMessage(L["Incontro in corso, riprova più tardi."],"WHISPER", nil, name)
		tinsert(self.invitiRichiesti,name)
		return
	end       
	
	--solo gildani
	if db.whisper.guildOnly then 
		local rank, rankIndex, lvl = self:IsInMyGuild(name)
		if not rank then return end --è non è gildano non invitiamo
		if db.whisper.maxLvlOnly and lvl < ERA.maxLvl then return end
		if db.whisper.minRank and db.whisper.minRankLvl and rankIndex > db.whisper.minRankLvl then return end							
	end
	
	self:Invita(name)
end

--name deve essere nella forma nome-server, lavora con la funzione cachingRoster
function ERA:IsInMyGuild(name) 
	if name and self.cachedRoster[name] then 
	local i = self.cachedRoster[name]
		return i.rank, i.rankIndex, i.lvl
	end
end

--return status red green o nil se non in gilda; cicla la lista di gilda, più lento (millisecondi) ma più affidabile 
--comunque non affidabile al 100% maledetta blizzard
function ERA:IsOnline(name)	
	local sName = ERA:GetName(name, true)	
	if not self:IsInMyGuild(sName) then return end --non ci mettiamo a cercare troppo se non e' in gilda, nessuna query al server	
	local fullName,online
	for i = 1, GetNumGuildMembers() do
	fullName,_,_,_ ,_,_,_,_, online = ERA:GetGuildRosterInfo(i) 
		if fullName == sName then 
			if online then 
				return L["Online"], 0, 1
			else
				return L["Offline"], 1, 0
			end
		end
	end	
	ERA:UpdateGuildRoster(true)--vediamo se fixa la rilevazione.
end
--copia il roster di gilda in una cache locale, per sapere in fretta se un'unità è un gildano. Memoria occupata risibile.
function ERA:CachingRoster()		
	self.cachedRoster = {}
	local fullName, rank, rankIndex, lvl -- per ERA:GetGuildRosterInfo
	for i = 1, GetNumGuildMembers() do
		fullName, rank, rankIndex,lvl,_,_,_,_, online = ERA:GetGuildRosterInfo(i) 
		self.cachedRoster[fullName] = {			
			["rank"] = rank, 
			["rankIndex"] = rankIndex, 			
			["lvl"] = lvl,
			["online"] = online
		}		
	end	
	self.fullRosterCaching = not next(self.cachedRoster)
	return not self.fullRosterCaching
end

--richiede l'update del guildroster ed eventualmente setta di copiarlo nella cache
--la copia la chiediamo al login/ricarica per controllare rapidamente chi è in gilda e chi no
--effettua 2 chiamate, una subito e una dopo 10 secondi, perchè a volte la chiamata viene ignorata. il server risponde infatti approssimativamente ogni 10 secondi (in realtà risponde prima, dato che ogni volta che qualcuno logga la finestra di gilda si aggiorna).
--la seconda chiamata viene cancellata se i dati di gilda sono disponibili prima.
function ERA:UpdateGuildRoster(notCaching)
	local timing = 10
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	GuildRoster()	
	if not self.updatingGuildRoster then 
		self.updatingGuildRoster = ERA:ScheduleTimer("UpdateGuildRoster", timing)
	end
	self.fullRosterCaching = not notCaching
end

--controlla quando si aggiorna il roster di gilda
function ERA:GUILD_ROSTER_UPDATE()
	--la seconda chiamata viene cancellata se i dati di gilda sono disponibili prima.
	if self.updatingGuildRoster then ERA:CancelTimer(self.updatingGuildRoster) end
	if self.fullRosterCaching then
		local guildDataAvailables = self:CachingRoster()	
		if guildDataAvailables then 
			if ERA.ExtremaIni then
				ERA:Extrema()
				--ERA:DialogBox()
			end
			if self.checkPromozioni then
				if not IsInRaid() then
					self:PromozioneCheck()
				end
				self.checkPromozioni = nil
			end
		end
	end		
end

--serve per vedere se il rank progress è attivo nonostante tutto
function ERA:PromozioneCheck()
	self.checkPromozioni = nil
	local rankIndex
	if db.promozione.up then 		
		local f
		for i = 1, GetNumGuildMembers() do
			_,_, rankIndex = ERA:GetGuildRosterInfo(i) 
			if db.promozione.up == rankIndex then 
				f = true 				
				break
			end		
		end		
		if f then			
			local act = CanGuildDemote() and L["Premi OK per sistemarlo ora"] or ""
			local msg = format(L["Persone al grado \|cFFFFFF00%s\|r.\n%s."], self.ranks[db.promozione.up], act)		
			ERA:AddAlert(msg, CanGuildDemote() and ERA.OpenTo or function()end,this,"promozione")
			--ERA:DialogBox()
		else
			db.promozione.ultraPromossi = {}			
		end	
	end		
end

function ERA:CanPromote()
	local name = ERA:GetName(GetUnitName("player"),true)
	local _, rankIndex = ERA:IsInMyGuild(name)
	return ((IsInRaid() or IsInGroup()) and CanGuildPromote() and db.promozione.up and db.promozione.up > rankIndex and not self.fullRosterCaching)	
end
--promozione ai rank scelti
function ERA:PromuoviGilda()
	if not ERA:CanPromote() then return end --se non puoi promuovere non ci scomodiamo		
	local membri = GetNumGroupMembers()
	if membri <1 then return end --sarebbe un controllo già fatto a dire il vero.
	self:UnregisterEvent("GUILD_ROSTER_UPDATE")	
	self.fullRosterCaching = true --anticipiamo il valore per evitare doppi click
	local name, rankIndex
	local where = IsInRaid() and "raid" or "party"		
	local wt = {} --la lista di tutti quelli che potenzialmente dovremmo promuovere
	for i = 1, membri do 
		name = ERA:GetName(GetUnitName(where..i,true),true)--serve forma nome-server quindi lo forzo		
		_,rankIndex = ERA:IsInMyGuild(name)
		if  rankIndex then --se e' di gilda lo inseriamo nella lista 			
			wt[name] = rankIndex
		end
	end
	--creata la lista facciamo le effettive promozioni	
	membri = GetNumGuildMembers()
	for i = 1, membri do	
		if not next(wt) then break end
		name, _, rankIndex = ERA:GetGuildRosterInfo(i)
		if wt[name] and rankIndex and rankIndex > db.promozione.up then			
			if db.promozione.down and rankIndex > db.promozione.down then
				db.promozione.ultraPromossi[name] = rankIndex	 --salviamo una lista con il rank di chi e' stato promosso da gradi bassi
			end
			SetGuildMemberRank(i, db.promozione.up)			
			wt[name] = nil	
		end		
	end	
	self:UpdateGuildRoster()
	--qui invia il messaggio che ho promosso agli altri addon e manda la lista
end

function ERA:CanDemote()	
	local name = ERA:GetName(GetUnitName("player"),true)
	local _, rankIndex = ERA:IsInMyGuild(name)
	return (CanGuildDemote() and db.promozione.up and db.promozione.up > rankIndex and db.promozione.down and db.promozione.down > rankIndex and db.promozione.down > db.promozione.up and not self.fullRosterCaching)
end
--degrada l rank scelto (o sotto se partivi da più basso)
function ERA:DegradaGilda()
	if not ERA:CanDemote() then return end --se non puoi degradare non ci scomodiamo			
	self:UnregisterEvent("GUILD_ROSTER_UPDATE")	
	self.fullRosterCaching = true --anticipiamo il valore per evitare doppi click
	local name, rankIndex, newRank
	--scorriamo tutta la gilda, troviamo chi e' al livello incriminato e lo potiamo in basso. riportiamo chi era ancora più in basso al livello originale
	for i = 1, GetNumGuildMembers() do	
		name, _, rankIndex = ERA:GetGuildRosterInfo(i)		
		if rankIndex and rankIndex == db.promozione.up then --se e' stato promosso
			if db.promozione.ultraPromossi[name] then 
				newRank = db.promozione.ultraPromossi[name]
				db.promozione.ultraPromossi[name] = nil
			else
				newRank = db.promozione.down
			end
			SetGuildMemberRank(i, newRank)				
		end
	end
	self:UpdateGuildRoster()
	--qui volendo invia il messaggio che ho promosso agli altri addon e manda la lista
end
--intercetta gli inviti con i whisper
function ERA:CHAT_MSG_WHISPER(...)--sender e' nella forma nome-server
local event, txt, sender = ...
	kword = match(txt, "^%s*(.+)%s*$")	
	--se la parola è sbagliata non invitiamo
	if not kword then return end
	if kword =="" then return end
	if (db.whisper.casesensitive and find(db.whisper.kwordList,kword)) or (not db.whisper.casesensitive and find(lower(db.whisper.kwordList), lower(kword))) then 
		self:WhisperInvita(sender)
	end
end


--era i o i pulsanti di invito
--effettua 2 tentativi di invito dei confermati a distanza di qualche secondo
function ERA:MassInvite()
	ERA:StartInvite()
	ERA:ScheduleTimer("StartInvite", ERA.totaldraft *0.5+20)
end
--invita tutti i confermati
function ERA:StartInvite()
	if not next(db.raid.drafted) then return end	
	--scorre la lista dei confermati e li invita
	if db.opzioni.monitor then
		self:ShowMonitor()
	end	
	for name in pairs(db.raid.drafted) do	
		self:Invita(name)
	end	
end

--WHISPER
--attiva o disattiva l'autoinvito. ignorato se si e' messo che deve essere sempre ON nelle opzioni
function ERA:SwitchWhisper(silent)	
	db.whisper.on = not db.whisper.on	
	if db.whisper.alwaysOn then		
		db.whisper.on = true
	end
	
	if not db.whisper.on then	
		self:UnregisterEvent("CHAT_MSG_WHISPER")	
		print(off)
	else
		self:RegisterEvent("CHAT_MSG_WHISPER")
		if db.whisper.annuncia and not silent then
			SendChatMessage(db.whisper.startMsg,"GUILD")
		end
		if db.opzioni.monitor and not silent then
			self:ShowMonitor()
		end		
		if not next(ERA.cachedRoster) then
			self:UpdateGuildRoster()	 
		end
		print(format("%s%s",on, db.whisper.alwaysOn and L[" SEMPRE!"] or ""))
	end
	self:AggiornaMonitor()
end

--****EPGP
--funzioni e controlli per i pulsanti di EPGP, per compattare le azioni in pochi tasti
--usa bottoni dinamici
function ERA:CanClickEPGPBtn(btn)
	local b = db.opzioni.EPGPUICfg[btn]
	return (ERA.EPGP and db.opzioni.EPGP and IsInRaid() and UnitIsGroupLeader("player") 
				and (not b.decay or ERA.EPGP:CanDecayEPGP())
				and (not b.award or ERA.EPGP:CanIncEPBy(b.reason, b.awardAmount))
				and (b.recurring == "start" and not ERA.EPGP:RunningRecurringEP() and ERA.EPGP:CanIncEPBy(b.reason, b.recurringAmount)
					or (b.recurring == "stop" and ERA.EPGP:RunningRecurringEP())
					or (b.recurring ~= "stop" and b.recurring ~= "start")
				)
			)
end
--usata nei bottoni dinamici
function ERA:ClickEPGPBtn(btn)
	local t = db.opzioni.EPGPTimer or 1 --il tempo di sicurezza, per evitare che EPGP si incasini con la scrittura nelle note di gilda.
	local b = db.opzioni.EPGPUICfg[btn]
	for k in pairs(db.opzioni.EPGPUICfg) do --disabilitiamo tutti i pulsanti per evitare doppi click, ed altri errori
		ERA.Monitor.Frame[k]:SetDisabled(true)
	end
	if b.recurring == "stop" then  
		EPGP:StopRecurringEP() 
	end
	if b.decay then 
		ERA:ScheduleTimer(function()ERA.EPGP:DecayEPGP() end, t) 
		t = t+3
	end
	if b.award then 
		ERA:ScheduleTimer(function()ERA.EPGP:IncMassEPBy(b.reason, b.awardAmount) end, t) 
		t = t+3
	end
	if b.recurring == "start" then 
		ERA.EPGP:RecurringEPPeriodMinutes(b.recurringTime)
		ERA:ScheduleTimer(function()ERA.EPGP:StartRecurringEP(b.reason, b.recurringAmount)end, t)
		t = t+1
	end
	ERA:ScheduleTimer(function()ERA:AggiornaMonitor()end, t)--riabilitiamo i giusti pulsanti
end

function ERA:EPGPBtnOptions()
	local btn = {
		type = "group",
		order = 10,
		inline = true,
		name = L["Pulsante "],
		desc =L["Seleziona le azioni che il pulsante deve automatizzare."],
		set = function(info, val)
			ERA:DBSet(info, val)
			ERA:AggiornaMonitor()
			--ERA:HelpOptions()
		end,
		args = {
			txt = {
				type = "input",
				order = 10,
				name = L["Nome"],
				desc = L["Il testo scritto nel pulsante. La prima parola costituisce anche un comando usabile in chat (cfr lista comandi)."],
				set = function(info,val) 
					ERA:DBSet(info, val)
					if ERA.Monitor and ERA.Monitor.Frame[info[#info-1]] then
						ERA.Monitor.Frame[info[#info-1]]:SetText(val)
					end
					ERA:DelEPGPBtnFromSlashCmd(info[#info-1])
					ERA:AddEPGPBtnToSlashCmd(info[#info-1])
				end,
			},
			decay = {
				type = "toggle",
				order = 20,
				name = L["Decay"],
				desc = L["Il pulsante effettua il decay."],
			},
			space = {
				type = "description",
				order = 30,
				width = "full",
				name = "",
			},
			award = {
				type = "toggle",
				order = 40,
				name = L["Mass EP Award"],
				desc = L["Il pulsante  assegna punti EP al raid."],
			},
			awardAmount = {
				type = "range",
				order = 50,
				min = 0,
				softMin = 50,
				softMax = 150,
				step = 1,
				name = L["EP"],
				desc = L["EP da assegnare."],			
				hidden = function(info)
					return not db.opzioni.EPGPUICfg[info[#info-1]].award
				end,
			},
			reason = {
				type = "input",
				order = 60,
				name = L["Motivo"],
				desc = L["Il motivo per il quale si danno i punti."],
				hidden = function(info) return not (db.opzioni.EPGPUICfg[info[#info-1]].award or db.opzioni.EPGPUICfg[info[#info-1]].recurring == "start") end,
			},
			space2 = {
				type = "description",
				order = 70,
				width = "full",
				name = "",
			},
			recurring = {
				type = "select",
				order = 80,
				values = {["start"]="Start",["stop"]="Stop",["no"]="No",},
				name = L["Recurring EP"],
				desc = L["Il pulsante assegna punti EP ricorrenti al raid o li ferma, o non influenza i punti ricorrenti (default)."],			
			},
			recurringAmount = {
				type = "range",
				order = 90,
				min = 0,
				softMin = 50,
				softMax = 150,
				step = 1,
				name = L["EP"],
				desc = L["EP da assegnare."],			
				hidden = function(info)
					return db.opzioni.EPGPUICfg[info[#info-1]].recurring ~= "start"
				end,
			},
			recurringTime = {
				type = "range",
				order = 100,
				min = 1,
				softMin = 5,
				softMax = 60,
				step = 1,
				name = L["Tempo (in minuti)"],
				desc = L["Frequenza di assegnazione dei punti ricorrenti."],			
				hidden = function(info)
					return db.opzioni.EPGPUICfg[info[#info-1]].recurring ~= "start"
				end,
			},
		},
	}
	ERA.EPGPBtnOptionsDef = btn
end

function ERA:NewEPGPBtnOpt(b)
	local n = type(b) =="string" and match(b,"(%d+)") or b
	local btn = setmetatable({}, {__index = ERA.EPGPBtnOptionsDef,})
	btn.order = n*10
	btn.name = btn.name..n	
	self.EPGPBtns["btn"..n] = btn
end

function ERA:AddNewEPGPBtn()		
	local n = 1
	for k in pairs(db.opzioni.EPGPUICfg) do
		n = n+1
	end
	local btn = "btn"..n
	db.opzioni.EPGPUICfg[btn] = {}
	db.opzioni.EPGPUICfg[btn].txt = L["Pulsante "]..n	
	ERA:NewEPGPBtnOpt(n)
	ERA:AddEPGPBtnToSlashCmd(btn)
	return n
end

--***********MONITOR***************

function ERA:CanInvite()
	return (not IsInGroup() and not IsInRaid()) or UnitIsGroupLeader("player") or UnitIsRaidOfficer("player")	
end

function ERA:MonitorLabelClick(w)

	if not ERA:CanInvite() then return end
	local stato = w:GetUserData("stato")
	local nome = w:GetUserData("nome")	
	local act = w:GetUserData("azione")	
	if act then
		if stato == status.potenziale then
			self:RegisterEvent("GROUP_ROSTER_UPDATE")
			self:Invita(nome)		
		end
		if stato == status.imbucato then
			UninviteUnit(nome)		
		end
	end
end

function ERA:InviteTooltipShow(w)
	local stato = w:GetUserData("stato")	
	local nome = w:GetUserData("nome")
	local act = stato ~= status.accettato and ERA:CanInvite() or nil
	w:SetUserData("azione", act)	
	local statoDes = format(aspetto[stato].txt,aspetto[stato].tooltip)		
	local action = format(aspetto[stato].txt,aspetto[stato].action)
	local cnctd, r, g = self:IsOnline(nome)		
	GameTooltip:SetOwner(w.frame,"ANCHOR_TOPLEFT")
	GameTooltip:SetText(statoDes)	
	if cnctd then
		GameTooltip:AddLine(cnctd,r,g,0) 						
	end
	if act and cnctd ~= L["Offline"] then
		GameTooltip:AddLine(action) 
	end
	GameTooltip:Show()
end

function ERA:EPGPBtnDesc(b)
	local txt = ""
	local btn = db.opzioni.EPGPUICfg[b]
	txt = format("%s%s", txt, btn.decay and L["effettua il decay, "] or "")
	txt = format("%s%s", txt, btn.award and format(L["da %s punti, "], btn.awardAmount or 0 ) or "")
	txt = format("%s%s", txt, btn.recurring == "start" and format(L["fa partire i punti dando %s EP ogni %s minuti."],btn.recurringAmount or 0,btn.recurringTime or 5) or "")		
	txt = format("%s%s", txt, btn.recurring == "stop" and L["ferma i punti EP ricorrenti."] or "")		
	txt = gsub(txt,"^%l", upper)
	txt = gsub(txt,",%s$",".")
	return txt
end

function ERA:BtnTooltipShow(w)	
	GameTooltip:SetOwner(w.frame,"ANCHOR_TOPLEFT")
	local txt = ""
	if w:GetUserData("tipo")== "EPGPBtn" then
		txt = ERA:EPGPBtnDesc(w:GetUserData("btn"))
	else
		txt = w:GetUserData("tltp")
	end
	GameTooltip:SetText(txt)
	GameTooltip:Show()
end

function ERA:TooltipHide()
	GameTooltip:Hide()
end

function ERA:MonitorUpdteList()
	if ERA.Monitor and ERA.Monitor:IsVisible() then
		ERA.Monitor.Drafted:SetText(ERA:DraftedToList())
	end	
end

function ERA:CreaLabel(name, i,stato)
	local label = "invito"..i
	local m = ERA.Monitor.Inviti	
--[[	ICONA	]]--
	m[label] = ACEGUI:Create("Icon")	
	m[label]:SetImage(aspetto[stato].icona)	
	m[label]:SetLabel(format(aspetto[stato].txt,name))	
	m[label]:SetImageSize(12,12)	
	m[label]:SetUserData("nome",name)
	m[label]:SetUserData("stato",stato)
	m[label]:SetCallback("OnEnter",function()ERA:InviteTooltipShow(m[label])end)
	m[label]:SetCallback("OnLeave",function()ERA:TooltipHide()end)
	m[label]:SetCallback("OnClick", function() ERA:MonitorLabelClick(m[label]) end)
	m:AddChild(m[label])
	
	return m[label]
end

--crea i nomi colorati per sapere chi abbiamo invitato o dobbiamo invitatare
function ERA:AggiornaVistaInviti()
	if not ERA.Monitor then return end	
	
	if ERA.UNKNOWN then --un aggiornamento per i fatti suoi è arrivato prima di quello fatto per fixare i nomi.
		ERA:CancelTimer(ERA.UNKNOWN)
	end
	
	ERA.Monitor.Inviti:ReleaseChildren()
	local r = 0
	local s = status.potenziale
	--intanto segnala tutti i confermati e il loro status.
	for nome in pairsByKeys(db.raid.drafted) do
		if not UnitIsUnit(ERA:GetName(nome), "player") then			
			if not ERA:InRaid(nome) and not ERA:InRaid(ERA:GetName(nome)) and not ERA:InRaid(ERA:GetName(nome,true)) then
				s = status.potenziale --(rosso)
			else
				s = status.accettato				
			end
			r = r+1
			self:CreaLabel (nome, r, s)
		end
	end
	--poi scorre la lista del gruppo e guarda se ci sono persone fuori dai confermati
	self.imbucati = 0
	if IsInRaid() then 
		for i = 1, GetNumGroupMembers() do
			if not UnitIsUnit("raid"..i,"player") then
				nome = GetUnitName("raid"..i, true)	
				if find(nome, UNKNOWNOBJECT) or find(nome, UNKNOWN) then
					ERA.UNKNOWN = ERA:ScheduleTimer("AggiornaVistaInviti",2)
				end
				snome = ERA:GetName(nome,true)
				dnome = ERA:GetName(nome)
				if not db.raid.drafted[nome] and not db.raid.drafted[snome] and not db.raid.drafted[dnome] then --BUG una persona con lo stesso nome ma di server differenti non risulta correttamente. Troppa fatica risolverlo
					r = r+1
					self.imbucati = self.imbucati + 1
					s = status.imbucato
					self:CreaLabel (nome,r,s) 
				end
			end
		end	
	end
end

function ERA:CreateMonitorUI()
	if not ERA.Monitor then return end
	ACEGUI = LibStub("AceGUI-3.0")
	local m = ERA.Monitor.Frame
	local m1 = ERA.Monitor
	--pulisce il vecchio
	m:ReleaseChildren()
	--Pulsanti per il controllo degli epgp
	--costruisce i nuovi (se c'e' EPGP e db.opzioni.EPGP)
	if ERA.EPGP and db.opzioni.EPGP then
		for k,v in pairsByKeys(db.opzioni.EPGPUICfg) do
			m[k] = ACEGUI:Create("Button")
			m[k]:SetText(v.txt)
			m[k]:SetRelativeWidth(0.5)
			m[k]:SetCallback("OnClick", function() ERA:ClickEPGPBtn(k) end)	
			m[k]:SetCallback("OnLeave", function() ERA:TooltipHide() end)	
			m[k]:SetCallback("OnEnter", function() ERA:BtnTooltipShow(m[k]) end)	
			m[k]:SetUserData("btn", k)--stesso comando di /era		
			m[k]:SetUserData("tipo", "EPGPBtn")
			m:AddChild(m[k])
		end
	end
	--editbox per la lista dei confermati
	m.Drafted = ACEGUI:Create("MultiLineEditBox")
	m1.Drafted = m.Drafted
	m.Drafted:SetNumLines(3)
	m.Drafted:SetRelativeWidth(1)
	m.Drafted:SetLabel(L["Lista confermati/Da Invitare"])
	m.Drafted:SetCallback("OnEnterPressed", function(widget, event, txt) widget:SetText(txt) 
			db.raid.list = txt
			ERA:ListToDrafted(_, txt) 
		end)
	m.Drafted:SetText(ERA:DraftedToList())
	m:AddChild(m.Drafted)	

	--pulsante invita
	m.Invita = ACEGUI:Create("Button")
	m.Invita:SetText(L["Invita confermati"])
	m.Invita:SetRelativeWidth(0.5)
	m.Invita:SetCallback("OnClick", function(...) ERA:MassInvite()	end)
	m.Invita:SetCallback("OnLeave", function() ERA:TooltipHide()	end)	
	m.Invita:SetCallback("OnEnter", function() ERA:BtnTooltipShow(m.Invita) end)	
	m.Invita:SetUserData("tltp", ERA.Com["i"].desc)--stesso comando di /era		
	m:AddChild(m.Invita)
	
	--whisper
	m.Whisp = ACEGUI:Create("Button")
	m.Whisp:SetText(L["Inviti da Whisper"]) 
	m.Whisp:SetRelativeWidth(0.5)
	m.Whisp:SetCallback("OnClick", function(...) ERA:SwitchWhisper() end)
	m.Whisp:SetCallback("OnLeave", function() ERA:TooltipHide()	end)	
	m.Whisp:SetCallback("OnEnter", function() ERA:BtnTooltipShow(m.Whisp) end)	
	m.Whisp:SetUserData("tltp", ERA.Com["w"].desc)--stesso comando di /era		
	m:AddChild(m.Whisp)
	
	--contenitore per invitati/confermati
	m.Inviti = ACEGUI:Create("InlineGroup")
	m1.Inviti = m.Inviti
	m.Inviti:SetTitle(L["Invitati/confermati"])
	m.Inviti:SetRelativeWidth(1)
	m.Inviti:SetLayout("Flow")
	m:AddChild(m.Inviti)
end

function ERA:IniMonitor()
	ACEGUI = LibStub("AceGUI-3.0")
	local m1 = ACEGUI:Create("Frame")
	ERA.Monitor = m1	
	m1:SetTitle("Monitor Inviti")
	self:UpdateStatus()	
	m1:SetLayout("fill")
	m1:SetWidth(500)	
	local m = ACEGUI:Create("ScrollFrame")
	m:SetLayout("flow")
	m1:AddChild(m)
	ERA.Monitor.Frame = m
	ERA:CreateMonitorUI()
	m1:Hide()
end

function ERA:UpdateStatus()
	if not ERA.Monitor then return end
	local txt = ""
	txt = format("%s%s%s%s%s", ERA.totaldraft > 0 and ERA.totaldraft or "", ERA.totaldraft > 0 and L[" confermati, "] or "", 
	self.imbucati > 0 and self.imbucati or "", self.imbucati > 0 and L[" \|cFF69CCF0imbucati\|r, "] or "", 
	db.whisper.on and on or off)
	ERA.Monitor:SetStatusText(txt)
end

function ERA:AggiornaMonitor()
	if ERA.Monitor and ERA.Monitor:IsVisible() then
		ERA:MonitorUpdteList()
		self:AggiornaVistaInviti()
		self:UpdateStatus()
		--setta la cliccabilità dei pulsanti EPGP
		for k in pairs(db.opzioni.EPGPUICfg) do
			if ERA.Monitor.Frame[k] then
				ERA.Monitor.Frame[k]:SetDisabled(not ERA:CanClickEPGPBtn(k))
			end
		end
	end
end

function ERA:ShowMonitor()
	if not ERA.Monitor then
		self:IniMonitor()
	end
	self.Monitor:Show()	
	self:AggiornaMonitor()		
end
--**************BOX**********************
function ERA:OpenTo(tab)
	LibStub("AceConfigDialog-3.0"):Open(addonName)	
	LibStub("AceConfigDialog-3.0"):SelectGroup(addonName, tab)
end

--crea e visualizza la coda di stampa
function ERA:AddAlert(msg, action, ...)
	local args = {...}
	local vars = { msg = msg, action = action, args = args,}
	tinsert(self.msgBuffer, vars)	
	ERA:DialogBox()
end

--mostra il primo messaggio in coda. alla chiusura richiama se stessa per mostrare eventuali altri o esce
function ERA:DialogBox()
	if ERA.Box and ERA.Box:IsShown() then return end
	local msg, action, args 
	if self.msgBuffer[1] then 
		msg = self.msgBuffer[1].msg		
		action = self.msgBuffer[1].action
		args = self.msgBuffer[1].args
		tremove(self.msgBuffer, 1)
	else
		return
	end	
	if not ERA.Box then
		local b = CreateFrame("Frame", nil, UIParent)
		b:SetWidth(250)
		b:SetHeight(150)
		b:SetPoint("CENTER", UIParent,"TOP",0,-150)

		b:SetBackdrop({
		  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		  tile = true,
		  tileSize = 32,
		  edgeSize = 32,
		  insets = { left=11, right=12, top=12, bottom=11 }
		}) 
		ERA.Box = b
		
		txt = b:CreateFontString()
		txt:SetFontObject(GameFontNormal)
		txt:SetTextColor(1, 1, 1)
		txt:SetPoint("TOP",b,"TOP",0,-35)
		txt:SetWidth(b:GetWidth()*0.75)
		txt:SetWordWrap(true)		
		ERA.Box.txt = txt
		
		local btnC = CreateFrame("Button",nil, b, "UIPanelButtonTemplate")
		btnC:SetWidth(75)
		btnC:SetHeight(30)
		btnC:SetPoint("BOTTOMLEFT", b, "BOTTOM", 5, 15)
		btnC:SetText(L["CANCEL"])
		btnC:SetScript("OnClick", function() b:Hide() end)	
		btnC:SetScript("PostClick", function() ERA:DialogBox() end)
		
		local btnK = CreateFrame("Button",nil, b, "SecureActionButtonTemplate,UIPanelButtonTemplate")
		btnK:SetWidth(75)
		btnK:SetHeight(30)
		btnK:SetPoint("BOTTOMRIGHT", b, "BOTTOM", -5, 15)
		btnK:SetAttribute("type", "macro")
		btnK:SetText(L["OK"])		
		ERA.Box.btnK = btnK
		b:Hide()
	end
	if action and action =="macro" and args and type(args[1]) == "string" then
		ERA.Box.btnK:SetAttribute("macrotext", args[1])		
	end
	ERA.Box.btnK:SetScript("PostClick", function() 
			ERA:Run(action,args)
			ERA.Box.btnK:SetAttribute("macrotext", "")
			ERA.Box:Hide()		
			ERA:DialogBox() 		
		end)		
	ERA.Box.txt:SetText(msg or "")		
	ERA.Box:Show()
end

function ERA:IniExtremaDB()
	if db.ExtremaIni then ERA.ExtremaIni = nil return end
	local i,btn,b
	local EPGPBtns = {
		{
			["txt"] = "Start EPGP",
			["recurring"] = "start",
			["decay"] = true,
			["award"] = true,
			["recurringTime"] = 30,
			["awardAmount"] = 100,
			["recurringAmount"] = 70,
			["reason"] = "Inizio Raid",
		},	
		{
			["txt"] = "Stop EPGP",
			["recurring"] = "stop",
			["awardAmount"] = 100,
			["award"] = true,
			["reason"] = "Fine Raid",	
		},
	}
	
	for _, t in ipairs(EPGPBtns) do
		i = ERA:AddNewEPGPBtn()
		btn = "btn"..i
		b = db.opzioni.EPGPUICfg[btn]
		for k, v in pairs(t) do
			b[k]=v
		end
		ERA:NewEPGPBtnOpt(btn)
		ERA:DelEPGPBtnFromSlashCmd(btn)
		ERA:AddEPGPBtnToSlashCmd(btn)
	end
	--
	db.roster = nil
	db.raid.roster = db.raid.roster or {
				["Galahtea"] = "Galahtea",["Séntenza"] = "Séntenza",["Petàrdo"] = "Petàrdo",["Sünny"] = "Sünny",["Reeve"] = "Reeve",["Clodefox"] = "Clodefox",	["Virust"] = "Virust",
				["Stormbeard"] = "Stormbeard",["Oxs"] = "Oxs",["Herdek"] = "Herdek",["Petardo"] = "Petardo",["Lunchi"] = "Lunchi",["Wuaca"] = "Wuaca",["Kichiga"] = "Kichiga",
				["Niikko"] = "Niikko",["Elowolf"] = "Elowolf",["Figolas"] = "Figolas",["Paryde"] = "Paryde",["Driedin"] = "Driedin",["Ossimoro"] = "Ossimoro",["Artémisìa"] = "Artémisìa",["Zandal"] = "Zandal",["Monnez"] = "Monnez",["Molokk"] = "Molokk",["Davided"] = "Davided",["Rèalangel"] = "Rèalangel",["Itzigo"] = "Itzigo",["Lygeìa"] = "Lygeìa",["Teobarbo"] = "Teobarbo",["Koccolina"] = "Koccolina",["Jeyla"] = "Jeyla",
			}

	db.promozione["up"] = 5--grado per la promozione		
	db.promozione["upName"] = "Progress" --nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
	db.promozione["downName"] = "Legionario"--nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
	db.promozione["down"] = 6--grado per la retrocessione
	db.promozione["MLooters"] = ""--list ML			
	db.promozione.assist="Stormbeard, Niikko" --lista assist

	db.ExtremaIni = true
	ERA.ExtremaIni = nil
end

function ERA:Extrema()	
	if db.ExtremaIni then ERA.ExtremaIni = nil return end	
	db.timesAskedExtremaIni =  db.timesAskedExtremaIni and db.timesAskedExtremaIni + 1 or 1
	if db.timesAskedExtremaIni > 3 then db.ExtremaIni = true; ERA.ExtremaIni = nil; return end	
	if GetGuildInfo("player") == "Extrema Ratio" then
		local msg  = "Vuoi settare \|cFFFF0000Figolas\|r con le opzioni base per la gilda?\n"
		msg = format("%s%s",msg, db.timesAskedExtremaIni == 2 and "Se premi Cancel te lo chiederò anche la prossima volta per sicurezza." or "")
		msg = format("%s%s",msg, db.timesAskedExtremaIni == 3 and "Questa questa è l'ultima volta che te lo chiedo, prometto!" or "")
		ERA:AddAlert(msg,ERA.IniExtremaDB,this)
	else
		db.ExtremaIni = true; ERA.ExtremaIni = nil;
	end
end

--***************************************
--***************************************
function ERA:OnInitialize()
	  -- Code that you want to run when the addon is first loaded goes here.
	self.db = LibStub("AceDB-3.0"):New("ERADB", DEFAULTDB)
	db = self.db.profile
	self.db.RegisterCallback(self, "OnNewProfile", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileChanged", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileDeleted", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileCopied", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileReset", "ManageProfile")
	--db = DEFAULTDB.profile
	--self.db = db
	
	--corregge errore su ini extrema
	if db.roster then 
		for k in pairs(db.roster) do
			db.raid.roster[k] = k
		end
		db.roster = nil 
	end
	
	ERA:AddAllEPGPBtnsToSlashCmd()--aggiunge i comandi creandoli dai pulsanti EPGP
	self:RegisterEvent("CHAT_MSG_SYSTEM") 
	self:RegisterEvent("GROUP_ROSTER_UPDATE")
	if db.whisper.safe then --su ini per prevenire gli inviti da whisper dopo un crash del RL
		self:RegisterEvent("ENCOUNTER_START")       
		self:RegisterEvent("ENCOUNTER_END")           
	end
	if db.promozione.tankAssist then
		self:RegisterEvent("ROLE_CHANGED_INFORM")  
		self:RegisterEvent("READY_CHECK")	
	end
	if db.whisper.alwaysOn or db.whisper.on then 
		self:SwitchWhisper(true)
	end		
	
	ERA.EPGP = _G.EPGP
--paranoico controllo per evitare casini: se manca anche solo una delle funzioni richieste allora non se ne fa nulla...
	if not (ERA.EPGP and ERA.EPGP.CanDecayEPGP and ERA.EPGP.CanIncEPBy and ERA.EPGP.DecayEPGP and ERA.EPGP.RecurringEPPeriodMinutes and ERA.EPGP.StartRecurringEP and ERA.EPGP.StopRecurringEP and ERA.EPGP.RunningRecurringEP) then
		ERA.EPGP = nil
	end
	ERA:EPGPBtnOptions()--lo inizializziamo cmq, perche' potrebbero esserci delle tabelle nelle opzioni da creare ma nascoste
	
	self.msgBuffer = {}
	self.ranks = {}
	self.cachedRoster = {}
	self.invitiRichiesti = {} 
	self.imbucati = 0--conta gli imbucati
	self.totaldraft = 0
	--per chat_msg_system locale
	local JOIN, ONLINE
	JOIN = gsub(ERR_JOINED_GROUP_S, "%%s", "")
	--ONLINE = gsub(ERR_FRIEND_ONLINE_SS, "%%s", "")--ERR_FRIEND_ONLINE_SS
	
	ERA[JOIN] = function(this,name)		
		if name and self.startedInviting then				
			ConvertToRaid()	
			ERA:AggiornaMonitor()
			self:UnregisterEvent("CHAT_MSG_SYSTEM") 
		end	
	end
end

function ERA:OnEnable()	
    -- Called when the addon is enabled	
	self:UpdateGuildRoster()
	if IsInGuild() then 
		for i = 1, GuildControlGetNumRanks() do		
			self.ranks[i] = GuildControlGetRankName(i)
		end
	else
		self.ranks[1] = L["Non in una gilda"]
	end
	self.maxLvl = GetMaxPlayerLevel()
	self.PGRealm = gsub(GetRealmName(),"%s","") 	
	self:IniOptions()	
	 ERA:AddBlizOpt()
	 
	ERA.ExtremaIni = not db.ExtremaIni
	
	--controlli sui ranghi di gilda salvati e attuali
	if db.whisper.minRank and db.whisper.minRankLvl and self.ranks[db.whisper.minRankLvl] ~= db.whisper.minRankName then
		local msg = L["Incongruenza tra i ranghi attuali di gilda e quelli salvati. Premi \|cFFFF0000OK\|r per controllare."]
		ERA:AddAlert(msg, ERA.OpenTo,this,"whisper")
	end

	if (db.promozione.up and self.ranks[db.promozione.up] ~= db.promozione.upName) or (db.promozione.down and self.ranks[db.promozione.down] ~= db.promozione.downName) then
		local msg = L["Incongruenza tra i ranghi attuali di gilda e quelli salvati. Premi \|cFFFF0000OK\|r per controllare."]
		ERA:AddAlert(msg, ERA.OpenTo,this,"promozione")
	end		
	self.checkPromozioni = true
	--ERA:DialogBox()
end

function ERA:OnDisable()
    -- Called when the addon is disabled
end

function ERA:ManageProfile(event, DB, prof)
	db = self.db.profile
	wipe(self.options)
	ERA:DelAllEPGPBtnsCmd()
	ERA:AddAllEPGPBtnsToSlashCmd()
	self:IniOptions()
	ERA:CreateMonitorUI()
	ERA:AggiornaMonitor()
end

--[[***************************************

SLASH COMMAND

******************************************]]
ERA.Com = {
	i = {
		desc=L["Invita tutti i confermati."],
		actn = function() ERA:MassInvite() end,	
	},
	w = {
		desc=L["Attiva/disattiva gli inviti con whisper."],
		actn = function() ERA:SwitchWhisper() end,	
	},
	m = {
		desc=L["Mostra il monitor degli inviti."],
		actn = function() if ERA.Monitor and ERA.Monitor:IsShown() then
				ERA.Monitor:Hide()
			else
				ERA:ShowMonitor()
			end 
		end,	
	},
	pro = {
		desc= function() return format(L["Promuove i membri del raid al grado %s"], db.promozione.upName and db.promozione.upName or L["scelto"])end,
		actn = function() if ERA:CanPromote() then ERA:PromuoviGilda() end end,	
	},
	de = {
		desc= function() return format(L["Degrada dal grado %s al grado %s"], db.promozione.upName and db.promozione.upName or L["scelto"], db.promozione.downName and db.promozione.downName or L["precedente"])end,
		actn = function() if ERA:CanDemote() then ERA:DegradaGilda() end end,	
	},
}

function ERA:Help()
	local msg = ""
	print(L["\|cFFFF0000FIGOLAS\|r Lista comandi\n"])
	for k, v in pairsByKeys(ERA.Com) do
		msg = format("\|cFFFFFF00/fig %-10s|r ---> \|cFF69CCF0%s\|r", k, type(v.desc) == "function" and v.desc() or v.desc)
		print(msg)
	end
end

function ERA:HelpOptions1()
	local df = {
		order = 100,
		type= "description",
		name = "test",
		fontSize = "medium",
	}
	local des = {}
	local msg, i = "", 0
	for k, v in pairsByKeys(ERA.Com) do		
		if not des[k] then des[k] = setmetatable({},{__index = df}) end
		des[k].name = function () return format("\|cFFFFFF00/fig %-10s|r ---> \|cFF69CCF0%s\|r\n", k, type(v.desc) == "function" and v.desc() or v.desc) end
		des[k].order = 100+i
		i = i+1
	end
	return des
end

function ERA:AddEPGPBtnToSlashCmd(btn)
	
	local cmd = match(db.opzioni.EPGPUICfg[btn].txt, "(%S+)"),""
	if not cmd then return end
	cmd = lower(cmd)
	local wcmd = cmd
	local i = 1
	while ERA.Com[wcmd] do
		wcmd = cmd..i
		i = i + 1		
		if i >100 then break end
	end
	ERA.Com[wcmd] = {
		desc = function() return ERA:EPGPBtnDesc(btn) end,
		actn = function() if ERA:CanClickEPGPBtn(btn) then ERA:ClickEPGPBtn(btn) end end,	
		ref = btn
	}
end

function ERA:DelEPGPBtnFromSlashCmd(btn)
	for k, v in pairs(ERA.Com) do
		if v.ref and v.ref == btn then
			ERA.Com[k] = nil
			break
		end
	end
end

function ERA:DelAllEPGPBtnsCmd()
	for k, v in pairs(ERA.Com) do
		if v.ref then 
			ERA.Com[k] = nil
		end
	end
end

function ERA:AddAllEPGPBtnsToSlashCmd()
	for btn in pairs(db.opzioni.EPGPUICfg) do
		ERA:AddEPGPBtnToSlashCmd(btn)
	end
end

function ERA:SlashCommand(msg)
	if not msg or msg =="" then
	--/era senza altro dietro apre il pannello delle opzioni
		LibStub("AceConfigDialog-3.0"):Open(addonName)	
		return
	end
	local op, other = match(msg,"(%S+)")--estrae l'argomento
	if op and ERA.Com[op] then ERA.Com[op].actn() else ERA:Help() end
end

SLASH_FIGOLAS1 ="/era"
SLASH_FIGOLAS2 ="/figolas"
SLASH_FIGOLAS3 ="/fig"
function SlashCmdList.FIGOLAS(msg)
	ERA:SlashCommand(msg)
end

--_______________OPTIONS_________

function ERA:AddBlizOpt()

	local options = { 
		name = "Figolas Options",
		type = "group",
		handler = ERA,				
		childGroups ="tab",
		args = {
			open = {
				order = 5,
				type = "execute",
				name = L["Apri Pannello delle opzioni"],				
				width = "double",
				func = function() 
						InterfaceOptionsFrame:Hide()                 
						HideUIPanel(GameMenuFrame)
						LibStub("AceConfigDialog-3.0"):Open(addonName)
					end
				},		
			hint = {
				order = 10,
				type = "description",
				name = L["Puoi usare anche il comando \|cFFFF0000/fig|r."],
				width = "full",
				fontSize = "large",
			
			},
		},		
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("BlizOpt", options)	
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BlizOpt", "Figolas")	
end

function ERA:IniOptions()
	local options = { 
		name = "Figolas Options",
		type = "group",
		handler = ERA,		
		get= "DBGet",
		set= "DBSet",	
		childGroups ="tab",
		args = {
			raid ={
				order = 20,
				type ="group",
				name = L["Draft e Roster"],
				desc = L["Lista di raiders e composizione del raid"],			
				args = {
					invita = {
						order = 5,
						type = "execute",
						name = L["Invita"],
						desc = L['"/fig i" - Invita tutti quelli nella lista dei confermati'],
						func = "MassInvite",
					},
					drafted = {
						order = 10,
						type = "group",
						name = "Drafted",
						inline = true,
						args = {
							
						},
					},
					_wipe = {
						order = 20,
						type = "execute",
						name = L["Cancella tutti i confermati"],
						desc = L["Elimina tutta lista dei confermati"],
						func = "WipeDrafted",
						
					},
					list = {
						order = 30,
						type = "input",
						width = "full",
						name = L["Lista dei confermati"],
						desc = L["Aggiungi i membri della lista ai confermati"],
						multiline = 4,						
						set = "ListToDrafted",
					},
					_add={
						type ="input",
						order = 40,
						name=L["Aggiungi un membro al roster"],
						width = "double",
						validate = "Validate",
						get = false,
						set = "AddToRoster",
					},
					_space = space(15, "half"),
					_rim = {
						order = 50	,
						type = "toggle",
						name = L["Rimuovi da roster"],
						desc = L["Seleziona per rimuovere i membri del roster"],	
						width = "full",						
						get = function ()
							return self.ar
						end,
						set = function(info,state,...)
							self.ar = state
							return state
						end,
					},					
					roster = {
						order = 70,
						type = "group",
						name = "Roster",
						desc=L["La lista di tutti i potenziali raidanti in gilda da cui scegliere"],
						inline = true,
						args = {
						},
					},
				},												
			},
			whisper = {
					order = 30,
					type ="group",
					name = L["AutoInvito/Whisper"],
					desc = L["Setta la parola chiave e altre opzioni."],
					args = {
						_startwhisper = {
						order = 5,
						type = "execute",
						name = function()
							local n = db.whisper.on and L["Blocca"] or L["Inizia"]
							return(n..L[" gli inviti"])						
						end,
						desc = L["/fig w - Fai partire/blocca la possibilità di autoinvitarsi."],						
						func = "SwitchWhisper",
						},
						alwaysOn = {
							order = 7,
							type = "toggle",
							name = L["Autoinvito sempre attivo"],
							width = "double",
							desc = L["Non è necessario avviare o fermare manualmente l'invito con i whisper. C'è a chi non da noia..."],							
							set = function(info, state) 							
								db.whisper.alwaysOn = state														
								ERA:SwitchWhisper(true)
							end,
						},
						_desc = {
							order = 8,
							type = "description",
							name = function()
								return(db.whisper.on and on or off)
							end,
						},
						safe = {
							order = 10,
							type = "toggle",
							name =L["Invito Sicuro"],
							desc=L["Se attivo non invita durante un boss fight."],
						},						
						_space1 = space(11),
						kwordList = {
							order = 20,
							type = "input",
							name = L["Parole Chiave"],
							width = "full",
							desc = L["Lista di parole per essere invitati in gruppo."],							
						},
						casesensitive = {
							order = 25,
							type = "toggle",
							width = "full",
							name =L["Distingui maiuscole/minuscole"],
							desc=L["Se attivo cerca un'esatta corrispondenza con le parole (es: Raid è diverso da raid)"],
						},						
						_space2 = space(28, "full"),
						annuncia = {
							order = 30,
							type = "toggle",
							width = "full",
							name =L["Annuncia quando partono gli inviti"],
							desc=L["Se attivo usa il messaggio sotto per annunciare l'apertura degli inviti."],
						},
						startMsg = {
							order = 40,
							type = "input",
							width = "full",
							name = L["Messaggio iniziale"],
							desc = L["Messaggio con il quale si annuncia l'apertura degli inviti."],
						},						
						_lim = {
							order = 60,
							type = "header",
							name =L["Limitazioni"],
							width = "full",
						},
						guildOnly = {
							order = 70,
							type = "toggle",
							name = L["Accetta solo membri della gilda."],
							desc = L["Autoinvita solo i membri della gilda."],
							width = "full",
						},
						maxLvlOnly = {
							order = 80,
							type = "toggle",
							name = function() return(L["Solo lvl "]..ERA.maxLvl)end,
							desc = L["Invita solo se chi sussurra è di massimo livello."],							
							disabled = function() return not db.whisper.guildOnly end,
						},
						minRank = {
							order = 90,
							type = "toggle",
							name = L["Richiede Grado minimo"],
							desc = L["Invita solo se chi sussurra ha un grado minimo in gilda."],
							disabled = function() return not db.whisper.guildOnly end,														
						},
						minRankLvl = {
							order = 100,
							type = "select",
							name = L["Grado minimo richiesto"],
							desc = L["Imposta il grado minimo richiesto."],
							values = ERA.ranks,
							style="dropdown",
							disabled = function() return not (db.whisper.minRank and db.whisper.guildOnly) end,							
							set = function(i, val) db.whisper.minRankLvl = val 
							db.whisper.minRankname = self.ranks[val] end,
						},						
						_space4 = space(140,"full"),
						_add={
							type ="input",
							order = 150,
							name=L["Aggiungi alla blacklist"],
							desc = L["Le persone nella lista non verranno invitate nonostante i whisper."],
							get = false,
							set = "AddToBlacklist",
							validate = "Validate",
							width = "double",
						},						
						_addTarget = {
							order = 160,
							type= "execute",
							name = L["Aggiungi bersaglio alla Blacklist"],
							desc = L["Il bersaglio verrà aggiunto alla blacklist."],
							func = function(info) 
								local name = GetUnitName("target", true)
								if name then
									ERA:AddToBlacklist(info,name)	
								end
							end,
						},
						blacklist = {
							order = 170,
							type = "group",
							name = L["Blacklist"],
							inline = true,
						args = {
							
						},
					},
						
				},
			},				
			promozione = {
				order = 50,
				type ="group",
					name = L["Promuovi/Degrada"],
					desc = L["Promuovi o degrada i membri ad un rank scelto."],
					args = {
						MLootTit = {
							order = 10,
							type = "header",
							name = L["Regole per il bottino"],
							width ="full",
						},
						forzaLM = {
							order = 15,
							type = "toggle",
							name = L["Forza il Loot Method"],		
							width = "full",							
							desc =L["Se attivo, setta automaticamente il Loot Method (Regola di Predazione -_-)."],
						},
						lootMethod = {
							order = 20,
							type = "select",
							name = L["Loot Method"],
							desc= L["Setta il tipo di regola per il bottino. Se su Master Looter cerca il responsabile nella lista."],
							values = {["freeforall"] = "Free for All",["roundrobin"] = "Rotazione Fissa",["group"] = "Group Loot",["needbeforegreed"] = "Need before Greed",["master"] = "Master Looter",["personalloot"]="Personale",},
							style="dropdown",							
						},
						MLooters = {
							order = 30,
							type ="input",
							width = "full",
							name = L["Lista di nomi separati da virgole e/o spazi"],
							desc=L["Il primo tra questi presente in gruppo sarà il Responsabile del Bottino. Se la lista è vuota o nessuno è presente si usano le impostazioni manuali."]						
						},
						AssistTit = {
							order = 50,
							type = "header",
							name = L["Lista Assistenti"],
							width ="full",
						},
						assist = {
							order = 60,
							type ="input",
							width = "full",
							name = L["Lista di nomi separati da virgole e/o spazi"],
							desc=L["Tutti quelli qui indicati saranno assistenti."],											
						},
						tankAssist = {
							order = 70,
							type = "toggle",
							name = L["Setta i tank come assistenti"],
							width = "full",
							desc =L["Se attivo promuove i tank ad assistenti."],							
							set = function(info, state) db.promozione.tankAssist = state 
									if not state then 
										ERA:UnregisterEvent("READY_CHECK")	
										ERA:UnregisterEvent("ROLE_CHANGED_INFORM")									
									else
										ERA:RegisterEvent("READY_CHECK")	
										ERA:RegisterEvent("ROLE_CHANGED_INFORM")									
									end
							end,						
						},
						ProDe = {
							order = 90,
							type = "header",
							name = L["Promuovi o Degrada i membri della Gilda"],
							width ="full",
						},				
						promuovi = {
							order = 110,
							type = "execute",
							name =L["Promuovi"],							
							desc=L["Promuovi i membri ad un rank scelto."],
							func = "PromuoviGilda",
							disabled = function() return not (IsInGuild() and ERA:CanPromote()) end,
						},
						up = {
							order = 120,
							type = "select",
							name = L["Gradi"],
							values = ERA.ranks,
							style="dropdown",							
							set = function(info, val) db.promozione.up = val 
								db.promozione.upName = self.ranks[val]
							end,
							disabled = function() return not IsInGuild() end,
						},
						_space1 = space(130),
						degrada = {
							order = 140,
							type = "execute",
							name =L["Degrada"],
							desc=L["Degrada i membri ad un rank scelto."],
							func = "DegradaGilda",
							disabled = function() return not (IsInGuild() and ERA:CanDemote()) end,
						},
						down = {
							order = 150,
							type = "select",
							name = L["Gradi"],
							values = ERA.ranks,
							style="dropdown",
							set = function(info, val) db.promozione.down = val 
								db.promozione.downName = self.ranks[val]
							end,
							disabled = function() return not IsInGuild() end,
						},
						
					},
			},
			opzioni = {
				order = 60,
				type ="group",
				name = L["Interfaccia e Varie"],
				args = {
					monitor = {
						order = 10,
						type = "toggle",
						name =L["Mostra il Monitor"],
						width="full",
						desc=L["Apri automaticamente il monitor quando partono gli inviti."],
					},						
					SetMT = {
						order = 20,
						type = "toggle",
						name =L["Setta Automaticamente i Main Tank"],
						width="full",
						desc=L["Controlla ad ogni Raid Check se i Main Tank sono assegnati correttamente, ed in caso contrario mostra un pulsante per settarli."],
					},					
					EPGP = {
						order = 30,
						type = "toggle",
						name = L["Usa EPGP"],
						desc = L["Abilita i pulsanti nel Monitor per velocizzare l'assegnazione dei punti. Numero e tipo di pulsanti possono essere personalizzati con i comandi successivi."],
						disabled = function() return not ERA.EPGP end,
						hidden = function() return not ERA.EPGP end,						
						set = function(info,val) 
							db.opzioni.EPGP = val
							--Aggiorna il monitor in modo da cambiare subito l'UI
							ERA:CreateMonitorUI()
							ERA:AggiornaMonitor()
						end
					},	
					EPGPUIMngBtns = {
						order = 40,
						type = "group",
						name = L["Quantità Pulsanti EPGP"],
						desc =L["Permette di personalizzare il numero dei pulsanti EPGP nel Monitor."],
						inline = true,
						hidden = function() return  not ERA.EPGP or not db.opzioni.EPGP end,
						args = {
							_addrem = {
								type = "select",
								order = 10,
								values = {["a"] = L["Aggiungi"],["r"] = L["Rimuovi"]},
								get = function() return ERA._addrem end;
								set = function(info, val) 
									for k,v in pairs(ERA._pulsanti) do
										ERA._pulsanti[k] = true
									end
									ERA._addrem = val 
									end;
								name = L["Azione"],
								desc = L["Permette di aggiungere o rimuovere un pulsante EPGP nel Monitor. Per rimuovere togli anche la spunta più sotto da quelli presenti che vuoi rimuovere. Per confermare l'azione premi Conferma."],
							},
							confirm = {
									type = "execute",
									order = 20,
									name = L["Conferma"],
									desc = L["Conferma le azioni selezionate."],
									func = function()																				
										if ERA._addrem == "a" then
											local n = ERA:AddNewEPGPBtn()											
											ERA._pulsanti["btn"..n] = true
										end
										if ERA._addrem == "r" then
											local wp, wdb = ERA._pulsanti, db.opzioni.EPGPUICfg
											ERA._pulsanti, db.opzioni.EPGPUICfg = {},{}
											local i = 0
											local b = ""
											ERA:DelAllEPGPBtnsCmd()
											for k, v in pairsByKeys(wdb) do
												ERA.EPGPBtns[k] = nil --per quale mistico motivo devo azzerarli uno per uno?												
												if wp[k] then												
													i = i+1													
													b = "btn"..i
													ERA._pulsanti[b] =  true
													db.opzioni.EPGPUICfg[b] = v
													ERA:NewEPGPBtnOpt(i)
													ERA:AddEPGPBtnToSlashCmd(b)
												end
											end											
										end		
										--ERA:HelpOptions()
										--Aggiorna il monitor se viene mostrato, in modo da presentare i cambiamenti subito
										ERA:CreateMonitorUI()
										ERA:AggiornaMonitor()
									end,
							},
							pulsanti = {
								type ="multiselect",
								style = "radio",
								name = L["Pulsanti"],
								desc = L["Togli la spunta dai pulsanti per rimuoverli, poi premi Conferma."],
								width = "half",
								values = function() 								
									if not next(db.opzioni.EPGPUICfg) then return {"nil"}end
									local l = {}
									local i = 0
									for k in pairsByKeys(db.opzioni.EPGPUICfg) do
										i = i+1
										l[k] = i										
									end									
									return l 
								end,
								disabled = function() return ERA._addrem ~= "r" end,
								hidden = function() return not next(db.opzioni.EPGPUICfg)end,
								get = function(info,btn) return ERA._pulsanti[btn] end,
								set = function(info,btn,val) ERA._pulsanti[btn] = val end,
							},
						},					
					},
					EPGPUICfg = {
						order = 50,
						type = "group",
						name = L["Configurazione Pulsanti EPGP"],
						desc =L["Permette di personalizzare le funzioni dei singoli pulsanti EPGP nel Monitor."],
						inline = true,
						hidden = function() return  not ERA.EPGP or not db.opzioni.EPGP or not next(db.opzioni.EPGPUICfg) end,
						args = {
						},
					},										
					desc = {
							order = 1000,
							type = "group",
							name = L["Comandi"],
							inline = true,
						args = {
							des = {
								order = 100,
								type= "description",		
								fontSize = "medium",
								name = function () 
								local msg = ""
									for k, v in pairsByKeys(ERA.Com) do		
										msg = format("%s\|cFFFFFF00/fig %-10s|r ---> \|cFF69CCF0%s\|r\n",msg, k, type(v.desc) == "function" and v.desc() or v.desc)
									end									
									return msg
								end	,
							},
						},
					},
				},
			},
			profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db),
		},
	}
	self.options = options
	self.roster = options.args.raid.args.roster.args
	self.drafted = options.args.raid.args.drafted.args
	self.blacklist = options.args.whisper.args.blacklist.args
	self.EPGPBtns = options.args.opzioni.args.EPGPUICfg.args
	self.helpDesc = options.args.opzioni.args.desc.args
	LibStub("AceConfig-3.0"):RegisterOptionsTable(addonName, options)	
	
	--allinea UI e db
	if next(db.raid.roster) then
		for name in pairs(db.raid.roster) do
			ERA:AddToRoster(_,name)
		end	
		ERA:SortView(ERA.roster)
	end	
	if next(db.raid.drafted) then
		for name in pairs(db.raid.drafted) do
			ERA:AddToDrafted(name)
		end	
		ERA:SortView(ERA.drafted)
	end	
	if next(db.whisper.blacklist) then
		for name in pairs(db.whisper.blacklist) do
			ERA:AddToBlacklist(nil,name)
		end	
		ERA:SortView(ERA.blacklist)
	end
	ERA._pulsanti = {}
	if next(db.opzioni.EPGPUICfg) then
		local i = 0		
		for k in pairsByKeys(db.opzioni.EPGPUICfg) do			
			i = i+1
			ERA:NewEPGPBtnOpt(i)
			ERA._pulsanti[k] = true
		end
	end	
end